Require Export ClosestProp.
Section F2.
Variable b:Fbound.
Variable precision:nat.

Local FtoRradix := (FtoR (2)).
Coercion FtoRradix : float >-> R.

Theorem TwoMoreThanOne: (lt (S O) (2)).
Auto.
Qed.
Hints Resolve TwoMoreThanOne.
Hypothesis precisionNotZero:(lt (1) precision).
Hypothesis pGivesBound:(vNum b)=(minus (exp (2) precision) (1)).

Theorem FevenNormMin: (Even (nNormMin (2) precision)).
Unfold nNormMin.
Generalize precisionNotZero; Case precision.
Intros H'2; Inversion H'2.
Intros n; Case n.
Intros H'2; Inversion H'2.
Inversion H0.
Intros n0 H'2; Replace (pred (S (S n0))) with (S n0).
Apply EvenExp with b := b radix := (2) precision := precision; Auto.
Apply EvenSS; Auto.
Apply EvenO; Auto.
Simpl; Auto.
Qed.

Theorem EvenFNSuccFNSuccMid:
  (p:float) (Fbounded b p) -> (FNeven b (2) precision p) ->
  <R>
    (Fminus
       (2) (FNSucc b (2) precision (FNSucc b (2) precision p))
       (FNSucc b (2) precision p))==(Fminus (2) (FNSucc b (2) precision p) p).
Intros p H' H'0.
Unfold FtoRradix; Apply FNSuccFNSuccMid; Auto.
Red; Intros H'1; Absurd (FNodd b (2) precision (FNSucc b (2) precision p)); Auto.
Unfold FNodd.
Rewrite FcanonicFormalizeEq; Auto with float arith.
Unfold Fodd.
Rewrite H'1.
Rewrite absolu_INR; Auto with float arith.
Apply EvenNOdd; Auto with float arith.
Apply FevenNormMin; Auto with float arith.
Apply FNevenSuc; Auto.
Red; Intros H'1; Absurd (FNodd b (2) precision (FNSucc b (2) precision p));
 Auto with float arith.
Unfold FNodd.
Rewrite FcanonicFormalizeEq; Auto with float arith.
Unfold Fodd.
Rewrite H'1.
Rewrite absolu_Zopp; Rewrite absolu_INR.
Apply EvenNOdd.
Apply FevenNormMin.
Qed.

Theorem AScal2:
  (p:float)<R> (Float (Fnum p) (Zplus (Fexp p) (1)))==(Rmult (2) p).
Intros p.
Unfold FtoRradix; Rewrite FvalScale; Auto.
Replace (powerRZ (2) (1)) with (INR (2)); [Idtac | Simpl; Ring]; Auto.
Qed.
End F2.
Hints Resolve FevenNormMin :float.
